using System;

namespace Smdn.Protocols.Imap4.Protocol {
  public class ImapProtocolResponseCode {
    public string Code {
      get { return code; }
    }

    public ImapData[] Data {
      get { return data; }
    }

    public ImapProtocolResponseCode(string code, ImapData[] data)
    {
      if (code == null)
        throw new ArgumentNullException("code");
      if (data == null)
        throw new ArgumentNullException("data");

      this.code = code;
      this.data = data;
    }

    public override string ToString()
    {
      return string.Format("{{Code={0}, Data={1}}}", code, (data == null) ? 0 : data.Length);
    }

    private string code = string.Empty;
    private ImapData[] data = null;
  }
}
