using System;

namespace Smdn.Protocols.Pop3.Transaction {
  public enum PopTransactionMethod {
    // transaction for initial server greeting
    Greeting,

    // transactions for  '4. The AUTHORIZATION State'
    Quit,     // QUIT Command
    UserPass, // USER Command and PASS Command (7. Optional POP3 Commands)
    Apop,     // APOP Command (7. Optional POP3 Commands)

    // transactions for  '5. The TRANSACTION State'
    Stat, // STAT Command
    List, // LIST Command
    Retr, // RETR Command
    Dele, // DELE Command
    NoOp, // NOOP Command
    Rset, // RSET Command
    Top,  // TOP Command  (7. Optional POP3 Commands)
    Uidl, // UIDL Command (7. Optional POP3 Commands)

    Capa,   // RFC 2449 POP3 Extension Mechanism
    Auth,   // RFC 1734 POP3 AUTHentication command
  }
}
