using System;

using Smdn.Protocols.Pop3.Protocol;

namespace Smdn.Protocols.Pop3.Transaction.Transactions {
  internal class PassTransaction : TransactionBase {

    // ProcessParameterNotSetted
    //   x Conclude
    // ProcessPass
    //   ->WaitForPass
    // WaitForPass
    //   x Conclude

    public PassTransaction(PopConnection connection, PopRequest request)
      : base(connection, request)
    {
    }

    protected override ProcessTransactionDelegate Reset()
    {
      if (Request.Parameters.ContainsKey("Password"))
        return ProcessPass;
      else
        return ProcessParameterNotSetted;
    }

    private void ProcessParameterNotSetted()
    {
      Conclude(new PopResponse(PopTransactionStatus.BadRequest, "parameter 'Password' must be setted"));
    }

    private void ProcessPass()
    {
      Send("PASS", Request.Parameters["Password"]);

      Transit(WaitForPass);
    }

    private void WaitForPass()
    {
      PopProtocolResponse response;

      if (!Receive(out response))
        return;

      if (response is PopStatusResponse) {
        var status = response as PopStatusResponse;

        if (status.Status == PopProtocolStatus.Positive) {
          Conclude(new PopResponse(PopTransactionStatus.Ok, "succeeded"));
        }
        else {
          ConcludeError(status);
        }
      }
    }
  }
}
